<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:my="myFunctions"
>
<!-- 
<purpose> generate a termMatrix for a model summary (queryModel)</purpose>
<strategy>match/merge model and CMD-profiles/components</strategy>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-10-09" type="created" by="vr"></change>
</history>
-->
<xsl:include href="./fcs/commons.xsl"/>
<!-- <xsl:include href="cmd_commons.xsl"/> --> 

<xsl:output method="xml" indent="yes" > </xsl:output>

<xsl:template name="continue-root">
	<xsl:apply-templates mode="matrix"  />
</xsl:template>
<xsl:param name="title" select="'Model matrix'"></xsl:param>


<!--<xsl:variable name="termsets-model" select="" />-->
<!--<xsl:variable name="termsets-datcat" select="" />-->


<xsl:template match="Termset|Terms" mode="matrix" >

	<!--  hack for bug: missing value in: Terms/Term/@name -->
	<xsl:variable name="termset_name" select="if (not(Term/@name='')) then Term/@name else replace(Term/@path,'/','')"></xsl:variable>

	<xsl:message>processing model-term: <xsl:value-of select="$termset_name" /> </xsl:message>
	
	<xsl:choose>
	<xsl:when test="$termset_name='all'" >
		<xsl:call-template name="full-matrix" />		
	</xsl:when>	
	<xsl:when test="$termset_name='Components'" >
		<xsl:message>model2matrix.Components.repo_name: <xsl:value-of select="$x-context" /></xsl:message>
		<!--  get the whole Termset for every root-node (teiHeader, TCP, ...) -->
		<Termsets>
		<xsl:for-each select="Term/Term" >
			<xsl:variable name="termset_name" select="@name" />						
			
			<xsl:variable name="termset_matrix" >
				<xsl:choose>
					<!-- if existing children, process directly those (enrich them in a separate matrix-run  -->
					<xsl:when test="Term">
						<xsl:variable name="terms" >							
							<Termset>
								<xsl:copy-of select="." />
							</Termset>	
						</xsl:variable>						
						
						<xsl:apply-templates select="$terms" mode="matrix" />						
					</xsl:when>
					<!--  else get the full summary for given termset -->
					<xsl:otherwise>
					<!-- <xsl:variable name="resolved_termset_uri" select="concat($model_matrix_uri,$termset_name,'&amp;maxdepth=8&amp;x-context=',$x-context)" /> -->
					<xsl:variable name="resolved_termset_uri" select="concat('',$termset_name,'&amp;maxdepth=8&amp;x-context=',$x-context)" />
						<xsl:message>processing model-term($resolved_termset_uri): <xsl:value-of select="$resolved_termset_uri" /> </xsl:message>			
						<xsl:copy-of select="document($resolved_termset_uri)" /> 
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			
			<!--<xsl:message><xsl:copy-of select="$termset" ></xsl:copy-of></xsl:message> --> 

<!-- this should be obsolete..
			<xsl:variable name="termset_matrix" >
				<xsl:for-each select="$termset" >
					<xsl:apply-templates mode="matrix"  />
				</xsl:for-each>				
			</xsl:variable>
	 -->					
			<Termset>
				<!-- <xsl:copy-of select="$terms_setup//Termset[@name=$termset_name]/@*"  />  -->
				<xsl:copy-of select="$termset_matrix/Termset/@*" />

				<xsl:copy-of select="$termset_matrix/Termset/*" />			
			</Termset>			
		</xsl:for-each>
		</Termsets>
	</xsl:when>
	<xsl:otherwise>
<!-- 		<xsl:variable name="termset_name" select="Term/@name" />
		<xsl:variable name="profile" select="my:profilematrix($termset_name)" />
		
		<xsl:message>corresponding profile: <xsl:value-of select="concat($profile/@name, '#', $profile/@id)"/>  </xsl:message>
		<xsl:variable name="setup_entry" select="Termset[@name=$termset_name]" />
		<xsl:message>corresponding terms_setup-entry: <xsl:value-of select="$setup_entry/concat(@name, '#', @id)"/>  </xsl:message>

		<xsl:variable name="prematrix">
			<Terms name="{$termset_name}">
				<xsl:copy-of select="@*"  />
				<xsl:copy-of select="$setup_entry/@*"  />
				<xsl:apply-templates mode="matrix"  >
					<xsl:with-param name="profile" select="$profile"></xsl:with-param>
				</xsl:apply-templates>				
			</Terms>
		</xsl:variable>
		
		<xsl:variable name="matrix">
			<Termset>
				<xsl:copy-of select="$prematrix/Terms/@*" />
			<xsl:for-each select="$prematrix/Terms/Term">
			
				<xsl:apply-templates select="." mode="min-context" >
					<xsl:with-param name="matrix" select="$prematrix"></xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each> 
			</Termset>
		</xsl:variable>
		
		<xsl:copy-of select="$matrix" />	
	 -->	
	</xsl:otherwise>	
	</xsl:choose>
	

</xsl:template>

<xsl:template name="full-matrix" >
<!--  collect all model termMatrix -->
<!-- 
		<xsl:variable name="model_termsets_uri" select="concat($model_matrix_uri,'Components', '&amp;maxdepth=1&amp;x-context=',$x-context)" />
	<xsl:message>full-matrix.model_termsets_uri: <xsl:value-of select="$model_termsets_uri"/>  </xsl:message>				
		<xsl:variable name="model_termsets" select="document($model_termsets_uri)" />




		<!-  collect all datcat terms 
		<xsl:variable name="datcats_uri" select="$datcats_terms_uri" />	
		<xsl:variable name="datcat_termsets" select="document($datcats_uri)" />

		<!-  resolve/invert datcat->Terms 		
		<xsl:variable name="datcat_termsets_resolved" >
				<xsl:apply-templates select="$datcat_termsets//Termset[@type='dcr']" mode="resolve-datcat" >
					<xsl:with-param name="model_termsets" select="$model_termsets" />
				</xsl:apply-templates> 
		</xsl:variable>
		
		<!- +  resolve RR: rels(datcat,datcat) 		
		<xsl:variable name="relcat_termsets_resolved" >
				<xsl:apply-templates select="$datcat_termsets//Termset[@type='rr']" mode="resolve-relcat" >
					<xsl:with-param name="datcat_termsets" select="$datcat_termsets_resolved" />
				</xsl:apply-templates> 
		</xsl:variable>
						
	<Termsets>
		<xsl:copy-of select="$model_termsets/Termsets/*" />
		<xsl:copy-of select="$datcat_termsets_resolved/*" />		
		<xsl:copy-of select="$relcat_termsets_resolved/*" />
	</Termsets>
	
		-->
</xsl:template>

<xsl:template match="Termsets|Termset" mode="resolve-datcat" >
	<xsl:param name="model_termsets" />
	<xsl:copy>
		<xsl:copy-of select="@*"></xsl:copy-of>
		<xsl:apply-templates mode="resolve-datcat">
				<xsl:with-param name="model_termsets" select="$model_termsets" />
		</xsl:apply-templates>
			
	</xsl:copy>
</xsl:template>

<xsl:template match="Term" mode="resolve-datcat" >
	<xsl:param name="model_termsets" />
	<xsl:copy>
		<xsl:attribute name="path" select="concat(ancestor::Termset/@id,':',@name)"></xsl:attribute>
		<xsl:copy-of select="*|@*"></xsl:copy-of>
		<xsl:variable name="matching_model_terms" select="$model_termsets//Term[@datcat=current()/@datcat]" />
<!-- 		<xsl:attribute name="name" select="$matching_model_terms/"></xsl:attribute>  -->
		<xsl:copy-of select="$matching_model_terms" />
	</xsl:copy>
</xsl:template>

<xsl:template match="Termsets|Termset" mode="resolve-relcat" >
	<xsl:param name="datcat_termsets" />
	<xsl:copy>
		<xsl:copy-of select="@*"></xsl:copy-of>
		<xsl:apply-templates mode="resolve-relcat">
				<xsl:with-param name="datcat_termsets" select="$datcat_termsets" />
		</xsl:apply-templates>			
	</xsl:copy>
</xsl:template>
		
<xsl:template match="Term[@type='rel']" mode="resolve-relcat" >
	<xsl:param name="datcat_termsets" />
	<xsl:copy>
		<xsl:variable name="matching_datcat_terms" select="$datcat_termsets//Term[@type='datcat'][@datcat=current()/@datcat]" />
		<!-- <xsl:variable name="matching_datcat_relterms" select="$datcat_termsets//Term[@datcat=current()/@datcat]" /> -->
		<xsl:variable name="name" select="($matching_datcat_terms//@name)[1]"></xsl:variable>
		<xsl:attribute name="name" select="$name"></xsl:attribute>
		<xsl:attribute name="path" select="concat(ancestor::Termset/@id,':',$name)"></xsl:attribute>
		<xsl:copy-of select="@*"></xsl:copy-of>		
		<xsl:copy-of select="$matching_datcat_terms" />
		<xsl:apply-templates select="Term[@type='rel']" mode="resolve-relcat">
			<xsl:with-param name="datcat_termsets" select="$datcat_termsets"/>
		</xsl:apply-templates>		
	</xsl:copy>
</xsl:template>

<!-- 
<xsl:template match="@*|*" mode="resolve-datcat" >	
	<xsl:copy-of select="." />
</xsl:template>
 -->

<!--  computing minimal unique path/index -->
<xsl:template match="Term" mode="min-context" >
	<xsl:param name="matrix" />
	<xsl:param name="term" select="." />
	
	
	<xsl:variable name="termset_id" select="if (exists(ancestor::Terms/@id)) then ancestor::Terms/@id else ancestor::Terms/@name" />
	
	<xsl:variable name="ambi_terms" select="$matrix//Term[lower-case(@name)=lower-case($term/@name)]" />
			
	<xsl:variable name="path" >			
			<!-- don't apply prefix for the root element (=profile-name) -->		
			<xsl:if test="not($term/parent::Terms)" >
				<xsl:value-of select="$termset_id" ></xsl:value-of><xsl:text>:</xsl:text>
			</xsl:if> 
			
			<xsl:choose>		
				<xsl:when test="count($ambi_terms) &gt; 1" >
						<xsl:variable name="ambi_terms_parent" select="$ambi_terms[@name=$term/@name]" />
							<xsl:variable name="term1" select="." />
							<xsl:message>Term:<xsl:value-of select="$term1/@context" />|ambi: <xsl:value-of select="count($ambi_terms)" />|</xsl:message>
							<xsl:variable name="minimal_contexts" >
								<xsl:for-each select="$ambi_terms[not(@context=$term1/@context)]" > 
		<!--						[position() &gt; current()/position()]" >			-->
									<item>									
										<xsl:variable name="diff"  select="my:diffContext($term1,.)" />
										<!-- <xsl:message>diff: <xsl:value-of select="count($diff)" /></xsl:message>-->
										<xsl:copy-of select="$diff" />									 
																											
									</item>									
								</xsl:for-each>
							</xsl:variable>
<!-- DEBUG:				diffcontext1:<xsl:value-of select="count($minimal_contexts)" />
|direct: <xsl:value-of select="count($minimal_contexts[1]/*)" />: <xsl:value-of select="$minimal_contexts[1]/*" />|
|item1: <xsl:value-of select="count($minimal_contexts/item[1]/*)" />: <xsl:value-of select="$minimal_contexts/item[1]/*" />|
						 cnt_mci:<xsl:value-of select="$minimal_contexts/*/count(tokenize(.,' '))" ></xsl:value-of>/
							 max-strlen:<xsl:value-of select="max($minimal_contexts/*/string-length(.))" ></xsl:value-of>
							 -->							 
						<xsl:variable name="last_contexts" select="distinct-values($minimal_contexts/*/tokenize(.,' ')[last()])" ></xsl:variable>
						<!--  to get the order right -->
						<xsl:for-each select="$last_contexts" >
							<xsl:sort select="index-of(tokenize($term1/@context,'\.'),.)[1]" /> 
								<xsl:value-of select="." />.</xsl:for-each>
			<!-- DEBUG: 	cnt_lc:<xsl:value-of select="count($last_contexts)" />}
						cnt_tok:<xsl:value-of select="count(tokenize($term1/@context,'\.'))" />
						 
						<xsl:for-each select="tokenize($term1/@context,'\.')" >
								tokenizing-context:<xsl:value-of select="." />,<xsl:value-of select="current()" />|
							<xsl:if test="$last_contexts[.=current()]" >
									{<xsl:value-of select="." />}

							</xsl:if>
						</xsl:for-each>
						-->
<!--								<xsl:value-of select="string-join(distinct-values($minimal_contexts/*/tokenize(.,' ')[last()]),'.')" ></xsl:value-of>		-->						
				</xsl:when>
				<xsl:otherwise>			
				</xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="@name" ></xsl:value-of>
	</xsl:variable>
	
	<xsl:copy>
		<xsl:copy-of select="@*"></xsl:copy-of>
<!-- 		<xsl:copy-of select="$path" />-->
			<xsl:attribute name="path" select="$path" />
		
		<xsl:apply-templates select="Term" mode="min-context" >
				<xsl:with-param name="matrix" select="$matrix"></xsl:with-param>
		</xsl:apply-templates>
			
		<xsl:copy-of select="v"  />
	</xsl:copy>							
	
</xsl:template>

<xsl:function name="my:diffContext" >
	<xsl:param name="c1" />
	<xsl:param name="c2" />
	 <!-- <xsl:message>C1:<xsl:copy-of select="count($c1/ancestor::Term/@name)" /></xsl:message> 
	 <xsl:message><xsl:value-of select="$c1/ancestor::Term/@name" /></xsl:message>
	 <xsl:message>C2:<xsl:value-of select="$c2/ancestor::Term/@name" /></xsl:message>
	  -->
<!--		<xsl:value-of select="($c1/ancestor::Term/@name except $c2/ancestor::Term/@name)[last()]" />-->

	<!-- <xsl:value-of select="string-join($c1/ancestor::Term/@name except $c2/ancestor::Term/@name,'.')" /> -->
	<!--   <xsl:copy-of select="$c1/ancestor::Term/@name except $c2/ancestor::Term/@name" />-->
	 <xsl:variable name="diff" select="$c1/ancestor::Term/xs:string(@name[not(.=$c2/ancestor::Term/@name)])" />
	 <!-- <xsl:message>diff: <xsl:value-of select="$diff" /></xsl:message>  -->
	   <xsl:copy-of select="$diff" />
	
</xsl:function>

<!--  obsoleted?!  -->
<xsl:function name="my:pick" >
	<xsl:param name="partial_result" />
	<xsl:param name="set" />

		<xsl:choose>
			<xsl:when test="count($set/*) &gt; 1" >
			<xsl:message>count-rest:<xsl:value-of select="count($set/*[position()&gt; 1])" /></xsl:message>					  
<!--					<xsl:variable  name="pickone" select="$set/*[1]/tokenize(.,' ')[last()]" />
			<xsl:variable  name="rest"  select="my:pick($pickone  $set/*[position()&gt; 1]))" />
				
					<xsl:message>rest:<xsl:value-of select="count($rest)" /></xsl:message>
				-->
				<!--  <xsl:choose>
					<xsl:when test="count($intersect &gt; 0)" >					
							<xsl:copy-of select="$intersect" />							
					</xsl:when>
					<xsl:otherwise>
						<xsl:message>no-intersect:</xsl:message>
							<xsl:message><xsl:value-of select="count($set/*[1])" />/<xsl:value-of select="count($set/*[1])" /></xsl:message>
							<xsl:copy-of select="$set/*[1] union my:intersect($set/*[position()&gt; 1])" />
					</xsl:otherwise>
				</xsl:choose>
				 -->		 		
			</xsl:when>
			<xsl:when test="count($set) = 1" >
				<xsl:copy-of select="$set[1]/*" />		
				<xsl:message>setitem1:<xsl:copy-of select="$set[1]/*" /></xsl:message>
			</xsl:when>
			<xsl:otherwise>				
			</xsl:otherwise>
		</xsl:choose>

	
</xsl:function>	

<xsl:function name="my:intersect" >	
	<xsl:param name="set" />
		<xsl:message>set-size:<xsl:value-of select="count($set/*)" /></xsl:message>
		<xsl:choose>
			<xsl:when test="count($set/*) &gt; 1" >
			<xsl:message>count-rest:<xsl:value-of select="count($set/*[position()&gt; 1])" /></xsl:message>
					<xsl:variable  name="rest"  select="my:intersect($set/*[position()&gt; 1])" />
					<xsl:message>rest:<xsl:value-of select="count($rest)" /></xsl:message>  
				<xsl:variable  name="intersect" select="$set/*[1][.=$rest/*]" />
				
				<xsl:message>intersect:<xsl:value-of select="count($intersect)" /></xsl:message>
				<xsl:choose>
					<xsl:when test="count($intersect &gt; 0)" >					
							<xsl:copy-of select="$intersect" />							
					</xsl:when>
					<xsl:otherwise>
						<xsl:message>no-intersect:</xsl:message>
							<xsl:message><xsl:value-of select="count($set/*[1])" />/<xsl:value-of select="count($set/*[1])" /></xsl:message>
							<xsl:copy-of select="$set/*[1] union my:intersect($set/*[position()&gt; 1])" />
					</xsl:otherwise>
				</xsl:choose>		 		
			</xsl:when>
			<xsl:when test="count($set) = 1" >
				<xsl:copy-of select="$set[1]/*" />		
				<xsl:message>setitem1:<xsl:copy-of select="$set[1]/*" /></xsl:message>
			</xsl:when>
			<xsl:otherwise>				
			</xsl:otherwise>
		</xsl:choose>
</xsl:function>

<!-- 
<xsl:function name="my:intersect" >
	<xsl:param name="set" />
	
	
			<xsl:value-of select="my:intersect(terms1 intersect *" />

	<xsl:for-each select="$set/item" >
		<xsl:variable name="terms1" select="*" />			
		<xsl:for-each select="$set/item" >
			<xsl:value-of select="my:intersect_pairwise(terms1,terms2) intersect *" />
			
		</xsl:for-each>
	</xsl:for-each>
	
</xsl:function>
-->

<xsl:template match="Term" mode="matrix" >
	<xsl:param name="profile" />

			<!-- <xsl:variable name="context" select="my:context(.)" > -->
			<xsl:variable name="context" select="''" >
							<!--  <xsl:for-each select="ancestor::CMD_Component" >
								<xsl:value-of select="@name" />.</xsl:for-each>-->
					</xsl:variable>	
			
			<xsl:variable name="corresp_cmdterm" select="if (parent::Terms) then $profile else $profile//*[@context=$context]" />					
			<!--
			<xsl:message>context: <xsl:copy-of select="$context" /> </xsl:message>  
			<xsl:message>corresp_cmdterm: <xsl:copy-of select="$profile/Term[@context=$context]" /> </xsl:message>--> 
			<xsl:variable name="datcat" select="$corresp_cmdterm/@datcat" >
					<!--  <xsl:for-each select="ancestor::CMD_Component" >
						<xsl:value-of select="@name" />.</xsl:for-each>-->
			</xsl:variable>
			<Term  elem="{@name}" datcat="{$datcat}" corresponding_component="{$corresp_cmdterm/@id}" 
							parent="{ancestor::Term[1]/@name}"  context="{$context}" >
							<xsl:copy-of select="@*[not(name()='path')]" /> 
				<xsl:apply-templates mode="matrix" >
					<xsl:with-param name="profile" select="$profile" />
				</xsl:apply-templates>
				
			</Term>
			
			
	
</xsl:template>

</xsl:stylesheet>